info = {
    'icon': 'RECOVER_LAST',
    'description': 'Duplicate current low as mid',
}

import bpy
from pathlib import Path
import re
# make a proxy through python

### / unused, just because it's interesting (but relinking break hide statement)
## https://blender.stackexchange.com/questions/157562/sorting-collections-alphabetically-in-the-outliner
def sort_collection(collection, case = False):

  if collection.children is None: return

  children = sorted (
    collection.children, 
    key = lambda c: c.name if case else c.name.lower()
  )

  for child in children:  
    collection.children.unlink(child)
    collection.children.link(child)
    sort_collection(child)

def sort_all_collection():
    # case_sensitive sort, (default is False)
    case_sensitive = True

    for scene in bpy.data.scenes:
        sort_collection(scene.collection, case_sensitive)
### unused /


def set_collection(ob, collection, unlink=True) :
    ''' link an object in a collection and create it if necessary, if unlink object is removed from other collections'''
    scn     = bpy.context.scene
    col     = None
    visible = False
    linked  = False

    # check if collection exist or create it
    for c in bpy.data.collections :
        if c.name == collection : col = c
    if not col : col = bpy.data.collections.new(name=collection)

    # link the collection to the scene's collection if necessary
    for c in scn.collection.children :
        if c.name == col.name : visible = True
    if not visible : scn.collection.children.link(col)

    # check if the object is already in the collection and link it if necessary
    for o in col.objects :
        if o == ob : linked = True
    if not linked : col.objects.link(ob)

    # remove object from scene's collection
    for o in scn.collection.objects :
        if o == ob : scn.collection.objects.unlink(ob)

    # if unlink flag we remove the object from other collections
    if unlink :
        for c in ob.users_collection :
            if c.name != collection : c.objects.unlink(ob)
    return col


# mid = None
# low = None
# for c in bpy.data.collections:
#     if re.search(r'vetement.*_mid', c.name, re.I):
#         mid = c
#     if re.search(r'vetement.*_low', c.name, re.I):
#         low = c

def backup_low_to_mid():
    low = mid = None
    for o in bpy.context.scene.objects:
        if re.search(r'vetements?_mid', o.name, re.I):
            mid = o
        if re.search(r'vetements?_low', o.name, re.I):
            low = o

    if not low:
        print('ERROR', 'low not found')
        return

    if not mid and low:
        #create mid by duplicating low
        mid = low.copy()
        mid.name = low.name.replace('_low', '_mid')
        mid.data = low.data.copy()# also copy data !
        mid.data.name = low.data.name.replace('_low', '_mid')
        col = set_collection(mid, mid.name)
        # hide viewport
        col.hide_viewport = True

    else:
        print('ERROR', 'mid already exists')
        return

backup_low_to_mid()